Index: cpukit/libdl/rtl-obj.h
===================================================================
--- cpukit/libdl/rtl-obj.h	(revision d51538bdbe5ea9e71a7205e39fcef387fbdb4b39)
+++ cpukit/libdl/rtl-obj.h	(revision d2e31f70c12f6363cef79ffad781df6ec0acdfb5)
@@ -57,5 +57,5 @@
 
 /**
- * The type of the format loader handler. This handler loads the specific
+ * The type of the format loader load handler. This handler loads the specific
  * format.
  */
@@ -63,6 +63,12 @@
 
 /**
- * The type of the format loader handler. This handler loads the specific
- * format.
+ * The type of the format loader unload handler. This handler unloads the
+ * specific format.
+ */
+typedef bool (*rtems_rtl_loader_unload) (rtems_rtl_obj_t* obj);
+
+/**
+ * The type of the format loader signature handler. This handler checks the
+ * format signature.
  */
 typedef rtems_rtl_loader_format_t* (*rtems_rtl_loader_sig) (void);
@@ -73,7 +79,8 @@
 typedef struct rtems_rtl_loader_table_s
 {
-  rtems_rtl_loader_check check;     /**< The check handler. */
-  rtems_rtl_loader_load  load;      /**< The loader. */
-  rtems_rtl_loader_sig   signature; /**< The loader's signature. */
+  rtems_rtl_loader_check  check;     /**< The check handler. */
+  rtems_rtl_loader_load   load;      /**< The loader. */
+  rtems_rtl_loader_unload unload;    /**< The unloader. */
+  rtems_rtl_loader_sig    signature; /**< The loader's signature. */
 } rtems_rtl_loader_table_t;
 
@@ -85,16 +92,28 @@
 #define RTEMS_RTL_OBJ_SECT_DATA  (1 << 2)  /**< Section holds program data. */
 #define RTEMS_RTL_OBJ_SECT_BSS   (1 << 3)  /**< Section holds program bss. */
-#define RTEMS_RTL_OBJ_SECT_REL   (1 << 4)  /**< Section holds relocation records. */
-#define RTEMS_RTL_OBJ_SECT_RELA  (1 << 5)  /**< Section holds relocation addend
+#define RTEMS_RTL_OBJ_SECT_EH    (1 << 4)  /**< Section holds exception data. */
+#define RTEMS_RTL_OBJ_SECT_REL   (1 << 5)  /**< Section holds relocation records. */
+#define RTEMS_RTL_OBJ_SECT_RELA  (1 << 6)  /**< Section holds relocation addend
                                             *   records. */
-#define RTEMS_RTL_OBJ_SECT_SYM   (1 << 6)  /**< Section holds symbols. */
-#define RTEMS_RTL_OBJ_SECT_STR   (1 << 7)  /**< Section holds strings. */
-#define RTEMS_RTL_OBJ_SECT_ALLOC (1 << 8)  /**< Section allocates runtime memory. */
-#define RTEMS_RTL_OBJ_SECT_LOAD  (1 << 9)  /**< Section is loaded from object file. */
-#define RTEMS_RTL_OBJ_SECT_WRITE (1 << 10) /**< Section is writable, ie data. */
-#define RTEMS_RTL_OBJ_SECT_EXEC  (1 << 11) /**< Section is executable. */
-#define RTEMS_RTL_OBJ_SECT_ZERO  (1 << 12) /**< Section is preset to zero. */
-#define RTEMS_RTL_OBJ_SECT_CTOR  (1 << 13) /**< Section contains constructors. */
-#define RTEMS_RTL_OBJ_SECT_DTOR  (1 << 14) /**< Section contains destructors. */
+#define RTEMS_RTL_OBJ_SECT_SYM   (1 << 7)  /**< Section holds symbols. */
+#define RTEMS_RTL_OBJ_SECT_STR   (1 << 8)  /**< Section holds strings. */
+#define RTEMS_RTL_OBJ_SECT_ALLOC (1 << 9)  /**< Section allocates runtime memory. */
+#define RTEMS_RTL_OBJ_SECT_LOAD  (1 << 10) /**< Section is loaded from object file. */
+#define RTEMS_RTL_OBJ_SECT_WRITE (1 << 11) /**< Section is writable, ie data. */
+#define RTEMS_RTL_OBJ_SECT_EXEC  (1 << 12) /**< Section is executable. */
+#define RTEMS_RTL_OBJ_SECT_ZERO  (1 << 13) /**< Section is preset to zero. */
+#define RTEMS_RTL_OBJ_SECT_LINK  (1 << 14) /**< Section is link-ordered. */
+#define RTEMS_RTL_OBJ_SECT_CTOR  (1 << 15) /**< Section contains constructors. */
+#define RTEMS_RTL_OBJ_SECT_DTOR  (1 << 16) /**< Section contains destructors. */
+#define RTEMS_RTL_OBJ_SECT_LOCD  (1 << 17) /**< Section has been located. */
+
+/**
+ * Section types mask.
+ */
+#define RTEMS_RTL_OBJ_SECT_TYPES (RTEMS_RTL_OBJ_SECT_TEXT | \
+                                  RTEMS_RTL_OBJ_SECT_CONST | \
+                                  RTEMS_RTL_OBJ_SECT_DATA | \
+                                  RTEMS_RTL_OBJ_SECT_BSS | \
+                                  RTEMS_RTL_OBJ_SECT_EH)
 
 /**
@@ -110,5 +129,5 @@
   size_t           size;        /**< The size of the section in memory. */
   off_t            offset;      /**< Offset into the object file. Relative to
-                                 * the start of the object file. */
+                                 *   the start of the object file. */
   uint32_t         alignment;   /**< Alignment of this section. */
   int              link;        /**< Section link field. */
@@ -117,4 +136,5 @@
   void*            base;        /**< The base address of the section in
                                  *   memory. */
+  int              load_order;  /**< Order we load sections. */
 };
 
@@ -136,4 +156,5 @@
   uint32_t             flags;        /**< The status of the object file. */
   uint32_t             users;        /**< References to the object file. */
+  int                  format;       /**< The format of the object file. */
   const char*          fname;        /**< The file name for the object. */
   const char*          oname;        /**< The object file name. Can be
@@ -154,24 +175,25 @@
   uint32_t             unresolved;   /**< The number of unresolved relocations. */
   void*                text_base;    /**< The base address of the text section
-                                      * in memory. */
+                                      *   in memory. */
+  size_t               text_size;     /**< The size of the text section. */
   void*                const_base;   /**< The base address of the const section
-                                      * in memory. */
+                                      *   in memory. */
+  void*                eh_base;      /**< The base address of the eh section
+                                      *   in memory. */
+  size_t               eh_size;      /**< The size of the eh section. */
   void*                data_base;    /**< The base address of the data section
-                                      * in memory. */
+                                      *   in memory. */
   void*                bss_base;     /**< The base address of the bss section
-                                      * in memory. */
+                                      *   in memory. */
   size_t               bss_size;     /**< The size of the bss section. */
   size_t               exec_size;    /**< The amount of executable memory
-                                      * allocated */
+                                      *   allocated */
   void*                entry;        /**< The entry point of the module. */
   uint32_t             checksum;     /**< The checksum of the text sections. A
-                                      * zero means do not checksum. */
-  void*                detail;       /**< The file details. It contains the elf file
-                                      * detail, mainly including elf file name,
-                                      * section offset, section size, which
-                                      * elf this section belongs to.*/
+                                      *   zero means do not checksum. */
   uint32_t*            sec_num;      /**< The sec nums of each obj. */
   uint32_t             obj_num;      /**< The count of elf files in an rtl obj. */
   struct link_map*     linkmap;      /**< For GDB. */
+  void*                loader;       /**< The file details specific to a loader. */
 };
 
@@ -259,4 +281,18 @@
 
 /**
+ * Is the address inside the text section?
+ *
+ * @param obj The object file.
+ * @return bool There is an archive name
+ */
+static inline bool rtems_rtl_obj_text_inside (const rtems_rtl_obj_t* obj,
+                                              const void*            address)
+{
+  return
+    (address >= obj->text_base) &&
+    (address < (obj->text_base + obj->text_size));
+}
+
+/**
  * Allocate an object structure on the heap.
  *
@@ -299,16 +335,4 @@
                            const char** oname,
                            off_t*       ooffset);
-
-/**
- * Load the object file.
- *
- * @param obj The object file's descriptor.
- * @param fd The file descriptor.
- * @param load_syms Load symbols.
- * @param load_dep Load dependent object files.
- * @retval true The load was successful.
- * @retval false The load failed. The RTL error has been set.
- */
-bool rtems_rtl_obj_file_load (rtems_rtl_obj_t* obj, int fd);
 
 /**
@@ -372,6 +396,6 @@
  * @return rtems_rtl_obj_sect_t* The named section.
  */
-rtems_rtl_obj_sect_t* rtems_rtl_obj_find_section (rtems_rtl_obj_t* obj,
-                                                  const char*      name);
+rtems_rtl_obj_sect_t* rtems_rtl_obj_find_section (const rtems_rtl_obj_t* obj,
+                                                  const char*            name);
 
 /**
@@ -383,19 +407,19 @@
  * @return rtems_rtl_obj_sect_t* The found section.
  */
-rtems_rtl_obj_sect_t* rtems_rtl_obj_find_section_by_index (rtems_rtl_obj_t* obj,
-                                                           int              index);
-
-/**
- * The text size of the object file. Only use once all the sections has been
- * added. It includes alignments between sections that are part of the object's
- * text area. The consts sections are included in this section.
+rtems_rtl_obj_sect_t* rtems_rtl_obj_find_section_by_index (const rtems_rtl_obj_t* obj,
+                                                           int                    index);
+
+/**
+ * The text section size. Only use once all the sections has been added. It
+ * includes alignments between sections that are part of the object's text
+ * area. The consts sections are included in this section.
  *
  * @param obj The object file's descriptor.
  * @return size_t The size of the text area of the object file.
  */
-size_t rtems_rtl_obj_text_size (rtems_rtl_obj_t* obj);
-
-/**
- * The text section alignment of the object file. Only use once all the
+size_t rtems_rtl_obj_text_size (const rtems_rtl_obj_t* obj);
+
+/**
+ * The text section alignment for the object file. Only use once all the
  * sections has been added. The section alignment is the alignment of the first
  * text type section loaded the text section.
@@ -407,18 +431,18 @@
  * @return uint32_t The alignment. Can be 0 or 1 for not aligned or the alignment.
  */
-uint32_t rtems_rtl_obj_text_alignment (rtems_rtl_obj_t* obj);
-
-/**
- * The const size of the object file. Only use once all the sections has been
- * added. It includes alignments between sections that are part of the object's
- * const area. The consts sections are included in this section.
+uint32_t rtems_rtl_obj_text_alignment (const rtems_rtl_obj_t* obj);
+
+/**
+ * The const section size. Only use once all the sections has been added. It
+ * includes alignments between sections that are part of the object's const
+ * area. The consts sections are included in this section.
  *
  * @param obj The object file's descriptor.
  * @return size_t The size of the const area of the object file.
  */
-size_t rtems_rtl_obj_const_size (rtems_rtl_obj_t* obj);
-
-/**
- * The const section alignment of the object file. Only use once all the
+size_t rtems_rtl_obj_const_size (const rtems_rtl_obj_t* obj);
+
+/**
+ * The const section alignment for the object file. Only use once all the
  * sections has been added. The section alignment is the alignment of the first
  * const type section loaded the const section.
@@ -430,18 +454,40 @@
  * @return uint32_t The alignment. Can be 0 or 1 for not aligned or the alignment.
  */
-uint32_t rtems_rtl_obj_const_alignment (rtems_rtl_obj_t* obj);
-
-/**
- * The data size of the object file. Only use once all the sections has been
- * added. It includes alignments between sections that are part of the object's
- * data area.
+uint32_t rtems_rtl_obj_const_alignment (const rtems_rtl_obj_t* obj);
+
+/**
+ * The eh section size. Only use once all the sections has been added. It
+ * includes alignments between sections that are part of the object's bss area.
+ *
+ * @param obj The object file's descriptor.
+ * @return size_t The size of the bss area of the object file.
+ */
+size_t rtems_rtl_obj_eh_size (const rtems_rtl_obj_t* obj);
+
+/**
+ * The eh section alignment for the object file. Only use once all the sections
+ * has been added. The section alignment is the alignment of the first bss type
+ * section loaded the bss section.
+ *
+ * You can assume the alignment is a positive integral power of 2 if not 0 or
+ * 1. If 0 or 1 then there is no alignment.
+ *
+ * @param obj The object file's descriptor.
+ * @return uint32_t The alignment. Can be 0 or 1 for not aligned or the alignment.
+ */
+uint32_t rtems_rtl_obj_eh_alignment (const rtems_rtl_obj_t* obj);
+
+/**
+ * The data section size. Only use once all the sections has been added. It
+ * includes alignments between sections that are part of the object's data
+ * area.
  *
  * @param obj The object file's descriptor.
  * @return size_t The size of the data area of the object file.
  */
-size_t rtems_rtl_obj_data_size (rtems_rtl_obj_t* obj);
-
-/**
- * The data section alignment of the object file. Only use once all the
+size_t rtems_rtl_obj_data_size (const rtems_rtl_obj_t* obj);
+
+/**
+ * The data section alignment for the object file. Only use once all the
  * sections has been added. The section alignment is the alignment of the first
  * data type section loaded the data section.
@@ -453,18 +499,17 @@
  * @return uint32_t The alignment. Can be 0 or 1 for not aligned or the alignment.
  */
-uint32_t rtems_rtl_obj_data_alignment (rtems_rtl_obj_t* obj);
-
-/**
- * The bss size of the object file. Only use once all the sections has been
- * added. It includes alignments between sections that are part of the object's
- * bss area.
+uint32_t rtems_rtl_obj_data_alignment (const rtems_rtl_obj_t* obj);
+
+/**
+ * The bss section size. Only use once all the sections has been added. It
+ * includes alignments between sections that are part of the object's bss area.
  *
  * @param obj The object file's descriptor.
  * @return size_t The size of the bss area of the object file.
  */
-size_t rtems_rtl_obj_bss_size (rtems_rtl_obj_t* obj);
-
-/**
- * The bss section alignment of the object file. Only use once all the
+size_t rtems_rtl_obj_bss_size (const rtems_rtl_obj_t* obj);
+
+/**
+ * The bss section alignment for the object file. Only use once all the
  * sections has been added. The section alignment is the alignment of the first
  * bss type section loaded the bss section.
@@ -476,5 +521,5 @@
  * @return uint32_t The alignment. Can be 0 or 1 for not aligned or the alignment.
  */
-uint32_t rtems_rtl_obj_bss_alignment (rtems_rtl_obj_t* obj);
+uint32_t rtems_rtl_obj_bss_alignment (const rtems_rtl_obj_t* obj);
 
 /**
Index: cpukit/libdl/rtl-rap.c
===================================================================
--- cpukit/libdl/rtl-rap.c	(revision d51538bdbe5ea9e71a7205e39fcef387fbdb4b39)
+++ cpukit/libdl/rtl-rap.c	(revision d2e31f70c12f6363cef79ffad781df6ec0acdfb5)
@@ -428,5 +428,5 @@
 
 /**
- * The structure of obj->detail is
+ * The structure of obj->linkmap is:
  *
  * |object_detail(0..obj_num)|section_detail(0..sec_num[0..obj_num])|
@@ -435,11 +435,13 @@
  */
 static bool
-rtems_rtl_rap_load_details (rtems_rtl_rap_t* rap, rtems_rtl_obj_t* obj)
-{
+rtems_rtl_rap_load_linkmap (rtems_rtl_rap_t* rap, rtems_rtl_obj_t* obj)
+{
+  void*            detail;
   struct link_map* tmp1;
-  section_detail* tmp2;
-  uint32_t obj_detail_size;
-  uint32_t pos = 0;
-  int i,j;
+  section_detail*  tmp2;
+  uint32_t         obj_detail_size;
+  uint32_t         pos = 0;
+  int              i;
+  int              j;
 
   obj_detail_size = sizeof (struct link_map) * obj->obj_num;
@@ -450,8 +452,8 @@
   }
 
-  obj->detail = rtems_rtl_alloc_new (RTEMS_RTL_ALLOC_OBJECT,
-                                     obj_detail_size + rap->strtable_size, true);
-
-  if (!obj->detail)
+  detail = rtems_rtl_alloc_new (RTEMS_RTL_ALLOC_OBJECT,
+                                obj_detail_size + rap->strtable_size, true);
+
+  if (!detail)
   {
     rap->strtable_size = 0;
@@ -460,13 +462,18 @@
   }
 
-  rap->strtable = obj->detail + obj_detail_size;
-
-  /* Read the obj names and section names */
-  if (!rtems_rtl_obj_comp_read (rap->decomp, rap->strtable,
+  rap->strtable = detail + obj_detail_size;
+
+  /*
+   *  Read the obj names and section names
+   */
+  if (!rtems_rtl_obj_comp_read (rap->decomp,
+                                rap->strtable,
                                 rap->strtable_size))
   {
-    rtems_rtl_alloc_del (RTEMS_RTL_ALLOC_OBJECT, obj->detail);
-    return false;
-  }
+    rtems_rtl_alloc_del (RTEMS_RTL_ALLOC_OBJECT, detail);
+    return false;
+  }
+
+  obj->linkmap = (struct link_map*) detail;
 
   if (rtems_rtl_trace (RTEMS_RTL_TRACE_DETAIL))
@@ -490,5 +497,5 @@
   for (i = 0; i < obj->obj_num; ++i)
   {
-    tmp1 = (struct link_map*) (obj->detail) + i;
+    tmp1 = obj->linkmap + i;
     tmp1->name = rap->strtable + pos;
     tmp1->sec_num = obj->sec_num[i];
@@ -510,5 +517,5 @@
   }
 
-  tmp2 =(section_detail*) ((struct link_map*) (obj->detail) + obj->obj_num);
+  tmp2 = (section_detail*) (obj->linkmap + obj->obj_num);
 
   for (i = 0; i < obj->obj_num; ++i)
@@ -516,9 +523,9 @@
     if (rtems_rtl_trace (RTEMS_RTL_TRACE_DETAIL))
     {
-      printf ("File %d: %s\n", i, ((struct link_map*) obj->detail + i)->name);
-      printf ("Section: %d sections\n",(unsigned int) obj->sec_num[i]);
-    }
-
-    ((struct link_map*)obj->detail + i)->sec_detail = tmp2;
+      printf ("File %d: %s\n", i, (obj->linkmap + i)->name);
+      printf ("Section: %d sections\n", (unsigned int) obj->sec_num[i]);
+    }
+
+    obj->linkmap[i].sec_detail = tmp2;
 
     for (j = 0; j < obj->sec_num[i]; ++j)
@@ -533,5 +540,6 @@
           !rtems_rtl_rap_read_uint32 (rap->decomp, &size))
       {
-        rtems_rtl_alloc_del (RTEMS_RTL_ALLOC_SYMBOL, obj->detail);
+        rtems_rtl_alloc_del (RTEMS_RTL_ALLOC_SYMBOL, obj->linkmap);
+        obj->linkmap = NULL;
         return false;
       }
@@ -908,5 +916,5 @@
       printf ("rtl: rap: details: obj_num=%lu\n", obj->obj_num);
 
-    if (!rtems_rtl_rap_load_details (&rap, obj))
+    if (!rtems_rtl_rap_load_linkmap (&rap, obj))
       return false;
   }
@@ -976,4 +984,11 @@
 }
 
+bool
+rtems_rtl_rap_file_unload (rtems_rtl_obj_t* obj)
+{
+  (void) obj;
+  return true;
+}
+
 rtems_rtl_loader_format_t*
 rtems_rtl_rap_file_sig (void)
Index: cpukit/libdl/rtl-rap.h
===================================================================
--- cpukit/libdl/rtl-rap.h	(revision d51538bdbe5ea9e71a7205e39fcef387fbdb4b39)
+++ cpukit/libdl/rtl-rap.h	(revision d2e31f70c12f6363cef79ffad781df6ec0acdfb5)
@@ -42,4 +42,11 @@
 
 /**
+ * The RAP format unload handler.
+ *
+ * @param obj The object to unload.
+ */
+bool rtems_rtl_rap_file_unload (rtems_rtl_obj_t* obj);
+
+/**
  * The RAP format signature handler.
  *
Index: cpukit/libdl/rtl-shell.c
===================================================================
--- cpukit/libdl/rtl-shell.c	(revision d51538bdbe5ea9e71a7205e39fcef387fbdb4b39)
+++ cpukit/libdl/rtl-shell.c	(revision d2e31f70c12f6363cef79ffad781df6ec0acdfb5)
@@ -26,5 +26,5 @@
  *  so we can't rely on prerdefines.
  */
-#if defined(__m32r__) || defined(__moxie__)
+#if defined(__moxie__)
 #define PRIdoff_t PRIo32
 #else
Index: cpukit/libdl/rtl-unwind-dw2.c
===================================================================
--- cpukit/libdl/rtl-unwind-dw2.c	(revision d2e31f70c12f6363cef79ffad781df6ec0acdfb5)
+++ cpukit/libdl/rtl-unwind-dw2.c	(revision d2e31f70c12f6363cef79ffad781df6ec0acdfb5)
@@ -0,0 +1,71 @@
+/*
+ *  COPYRIGHT (c) 2012-2016 Chris Johns <chrisj@rtems.org>
+ *
+ *  The license and distribution terms for this file may be
+ *  found in the file LICENSE in this distribution or at
+ *  http://www.rtems.org/license/LICENSE.
+ */
+/**
+ * @file
+ *
+ * @ingroup rtems_rtld
+ *
+ * @brief RTEMS Run-Time Link Editor
+ *
+ * This is the RTL implementation.
+ */
+
+#if HAVE_CONFIG_H
+#include "config.h"
+#endif
+
+#include <string.h>
+#include <stdio.h>
+
+#include <rtems/rtl/rtl.h>
+#include "rtl-elf.h"
+#include "rtl-error.h"
+#include "rtl-unwind.h"
+#include "rtl-unwind-dw2.h"
+
+/*
+ * These interfaces are not exported outside the GCC source.
+ */
+void __register_frame (void *begin);
+void __deregister_frame (void *begin);
+
+bool
+rtems_rtl_elf_unwind_dw2_parse (const rtems_rtl_obj_t* obj,
+                                const char*            name,
+                                uint32_t               flags)
+{
+  return
+    ((flags & RTEMS_RTL_OBJ_SECT_CONST) != 0) &&
+    ((strcmp(name, ".eh_frame") == 0) ||
+     (strncmp(name, ".gcc_except_table.", sizeof (".gcc_except_table.") - 1) == 0));
+}
+
+bool
+rtems_rtl_elf_unwind_dw2_register (const rtems_rtl_obj_t* obj)
+{
+  rtems_rtl_obj_sect_t* sect = rtems_rtl_obj_find_section (obj, ".eh_frame");
+
+  if (sect != NULL && sect->size > 0 && sect->base != NULL)
+  {
+    __register_frame (sect->base);
+  }
+
+  return true;
+}
+
+bool rtems_rtl_elf_unwind_dw2_deregister (const rtems_rtl_obj_t* obj)
+{
+  rtems_rtl_obj_sect_t* sect = rtems_rtl_obj_find_section (obj, ".eh_frame");
+
+  if (sect != NULL && sect->size > 0 && sect->base != NULL)
+  {
+    __deregister_frame (sect->base);
+  }
+
+  return true;
+}
Index: cpukit/libdl/rtl-unwind-dw2.h
===================================================================
--- cpukit/libdl/rtl-unwind-dw2.h	(revision d2e31f70c12f6363cef79ffad781df6ec0acdfb5)
+++ cpukit/libdl/rtl-unwind-dw2.h	(revision d2e31f70c12f6363cef79ffad781df6ec0acdfb5)
@@ -0,0 +1,83 @@
+/*
+ *  COPYRIGHT (c) 2016 Chris Johns <chrisj@rtems.org>
+ *
+ *  The license and distribution terms for this file may be
+ *  found in the file LICENSE in this distribution or at
+ *  http://www.rtems.org/license/LICENSE.
+ */
+/**
+ * @file
+ *
+ * @ingroup rtems_rtl
+ *
+ * @brief RTEMS Run-Time Linker Unwind DWARF  Support.
+ */
+
+#if !defined (_RTEMS_RTL_UNWIND_DW2_H_)
+#define _RTEMS_RTL_UNWIND_DW2_H_
+
+#include "rtl-elf.h"
+
+#ifdef __cplusplus
+extern "C" {
+#endif /* __cplusplus */
+
+#if __SIZEOF_LONG__ >= __SIZEOF_POINTER__
+  typedef long rtems_rtl_elf_unwind_dw2_sleb128;
+  typedef unsigned long rtems_rtl_elf_unwind_dw2_uleb128;
+#elif __SIZEOF_LONG_LONG__ >= __SIZEOF_POINTER__
+  typedef long long rtems_rtl_elf_unwind_dw2_sleb128;
+  typedef unsigned long long rtems_rtl_elf_unwind_dw2_uleb128;
+#else
+  #error No DW2 type available.
+#endif
+
+/**
+ * Architecture specific handler to check if a section contains exception
+ * handler data..
+ *
+ * @param obj The object file.
+ * @param name The section's name.
+ * @param uint32 flags The object file's flags.
+ * @retval true The section contains unwind information.
+ * @retval false The section does not contain unwind information.
+ */
+bool rtems_rtl_elf_unwind_dw2_parse (const rtems_rtl_obj_t* obj,
+				     const char*            name,
+				     uint32_t               flags);
+
+/**
+ * Architecture specific handler to add an object file's unwind information to
+ * the base image.
+ *
+ * @param obj The object file.
+ * @retval true The unwind information has been registered.
+ * @retval false The unwind information could not be registered.
+ */
+bool rtems_rtl_elf_unwind_dw2_register (const rtems_rtl_obj_t* obj);
+
+/**
+ * Architecture specific handler to remove an object file's unwind information
+ * from the base image.
+ *
+ * @param obj The object file.
+ * @retval true The unwind information has been deregistered.
+ * @retval false The unwind information could not be deregistered.
+ */
+bool rtems_rtl_elf_unwind_dw2_deregister (const rtems_rtl_obj_t* obj);
+
+/**
+ * Read signed and unsigned LEB128 values.
+ */
+const uint8_t* rtems_rtl_elf_unwind_dw2_read_uleb128 (const uint8_t*                    data,
+						      rtems_rtl_elf_unwind_dw2_uleb128* val);
+const uint8_t* rtems_rtl_elf_unwind_dw2_read_sleb128 (const uint8_t*                    data,
+						      rtems_rtl_elf_unwind_dw2_sleb128* val);
+
+bool rtems_rtl_elf_unwind_dw2_relocate (const Elf_Addr* where, Elf_Word value, Elf_Word mask);
+
+#ifdef __cplusplus
+}
+#endif /* __cplusplus */
+
+#endif
Index: cpukit/libdl/rtl-unwind.h
===================================================================
--- cpukit/libdl/rtl-unwind.h	(revision d2e31f70c12f6363cef79ffad781df6ec0acdfb5)
+++ cpukit/libdl/rtl-unwind.h	(revision d2e31f70c12f6363cef79ffad781df6ec0acdfb5)
@@ -0,0 +1,63 @@
+/*
+ *  COPYRIGHT (c) 2016 Chris Johns <chrisj@rtems.org>
+ *
+ *  The license and distribution terms for this file may be
+ *  found in the file LICENSE in this distribution or at
+ *  http://www.rtems.org/license/LICENSE.
+ */
+/**
+ * @file
+ *
+ * @ingroup rtems_rtl
+ *
+ * @brief RTEMS Run-Time Linker Unwind Support.
+ */
+
+#if !defined (_RTEMS_RTL_UNWIND_H_)
+#define _RTEMS_RTL_UNWIND_H_
+
+#include "rtl-elf.h"
+
+#ifdef __cplusplus
+extern "C" {
+#endif /* __cplusplus */
+
+/**
+ * Architecture specific handler to check if a section contains exception
+ * handler data..
+ *
+ * @param obj The object file.
+ * @param name The section's name.
+ * @param uint32 flags The object file's flags.
+ * @retval true The section contains unwind information.
+ * @retval false The section does not contain unwind information.
+ */
+bool rtems_rtl_elf_unwind_parse (const rtems_rtl_obj_t* obj,
+                                 const char*            name,
+                                 uint32_t               flags);
+
+/**
+ * Architecture specific handler to add an object file's unwind information to
+ * the base image.
+ *
+ * @param obj The object file.
+ * @retval true The unwind information has been registered.
+ * @retval false The unwind information could not be registered.
+ */
+bool rtems_rtl_elf_unwind_register (rtems_rtl_obj_t* obj);
+
+/**
+ * Architecture specific handler to remove an object file's unwind information
+ * from the base image.
+ *
+ * @param obj The object file.
+ * @retval true The unwind information has been deregistered.
+ * @retval false The unwind information could not be deregistered.
+ */
+bool rtems_rtl_elf_unwind_deregister (rtems_rtl_obj_t* obj);
+
+#ifdef __cplusplus
+}
+#endif /* __cplusplus */
+
+#endif
Index: cpukit/libdl/rtl.c
===================================================================
--- cpukit/libdl/rtl.c	(revision d51538bdbe5ea9e71a7205e39fcef387fbdb4b39)
+++ cpukit/libdl/rtl.c	(revision d2e31f70c12f6363cef79ffad781df6ec0acdfb5)
@@ -63,4 +63,5 @@
  */
 static rtems_rtl_data_t* rtl;
+static bool              rtl_data_init;
 
 /**
@@ -94,4 +95,17 @@
       rtems_status_code sc;
       rtems_id          lock;
+
+      /*
+       * We cannot set an error in this code because there is no RTL data to
+       * hold it.
+       */
+
+      if (rtl_data_init)
+      {
+        rtems_libio_unlock ();
+        return false;
+      }
+
+      rtl_data_init = true;
 
       /*
@@ -101,4 +115,5 @@
       if (!rtl)
       {
+        rtems_libio_unlock ();
         errno = ENOMEM;
         return false;
@@ -121,4 +136,5 @@
       {
         free (rtl);
+        rtems_libio_unlock ();
         return false;
       }
@@ -129,4 +145,5 @@
         rtems_semaphore_delete (lock);
         free (rtl);
+        rtems_libio_unlock ();
         return false;
       }
@@ -144,4 +161,5 @@
         rtems_semaphore_delete (lock);
         free (rtl);
+        rtems_libio_unlock ();
         return false;
       }
@@ -153,4 +171,5 @@
         rtems_semaphore_delete (lock);
         free (rtl);
+        rtems_libio_unlock ();
         return false;
       }
@@ -163,4 +182,5 @@
         rtems_semaphore_delete (lock);
         free (rtl);
+        rtems_libio_unlock ();
         return false;
       }
@@ -174,4 +194,5 @@
         rtems_semaphore_delete (lock);
         free (rtl);
+        rtems_libio_unlock ();
         return false;
       }
@@ -186,4 +207,5 @@
         rtems_semaphore_delete (lock);
         free (rtl);
+        rtems_libio_unlock ();
         return false;
       }
@@ -199,4 +221,5 @@
         rtems_semaphore_delete (lock);
         free (rtl);
+        rtems_libio_unlock ();
         return false;
       }
@@ -213,4 +236,5 @@
         rtems_semaphore_delete (lock);
         free (rtl);
+        rtems_libio_unlock ();
         return false;
       }
@@ -289,5 +313,5 @@
 
 void
-rtems_rtl_obj_caches_flush ()
+rtems_rtl_obj_caches_flush (void)
 {
   if (rtl)
@@ -439,4 +463,5 @@
     {
       rtems_rtl_obj_free (obj);
+      rtems_rtl_obj_caches_flush ();
       return NULL;
     }
@@ -447,6 +472,9 @@
     {
       rtems_rtl_obj_free (obj);
+      rtems_rtl_obj_caches_flush ();
       return NULL;
     }
+
+    rtems_rtl_obj_caches_flush ();
 
     rtems_rtl_unresolved_resolve ();
@@ -515,4 +543,7 @@
 
     ok = rtems_rtl_obj_unload (obj);
+
+    rtems_rtl_obj_free (obj);
+    rtems_rtl_obj_caches_flush ();
   }
 
Index: cpukit/libdl/rtl.h
===================================================================
--- cpukit/libdl/rtl.h	(revision d51538bdbe5ea9e71a7205e39fcef387fbdb4b39)
+++ cpukit/libdl/rtl.h	(revision d2e31f70c12f6363cef79ffad781df6ec0acdfb5)
@@ -113,5 +113,5 @@
 
 /**
- * Get the RTL data with out locking. This call assmes the RTL is locked.
+ * Get the RTL data with out locking. This call assumes the RTL is locked.
  *
  * @return rtems_rtl_data_t* The RTL data after being locked.
Index: cpukit/preinstall.am
===================================================================
--- cpukit/preinstall.am	(revision d51538bdbe5ea9e71a7205e39fcef387fbdb4b39)
+++ cpukit/preinstall.am	(revision d2e31f70c12f6363cef79ffad781df6ec0acdfb5)
@@ -213,4 +213,8 @@
 PREINSTALL_FILES += $(PROJECT_INCLUDE)/rtems/rtl/rtl-sym.h
 
+$(PROJECT_INCLUDE)/rtems/rtl/rtl-trace.h: libdl/rtl-trace.h $(PROJECT_INCLUDE)/rtems/rtl/$(dirstamp)
+	$(INSTALL_DATA) $< $(PROJECT_INCLUDE)/rtems/rtl/rtl-trace.h
+PREINSTALL_FILES += $(PROJECT_INCLUDE)/rtems/rtl/rtl-trace.h
+
 $(PROJECT_INCLUDE)/rtems/rtl/rap.h: libdl/rap.h $(PROJECT_INCLUDE)/rtems/rtl/$(dirstamp)
 	$(INSTALL_DATA) $< $(PROJECT_INCLUDE)/rtems/rtl/rap.h
Index: testsuites/libtests/Makefile.am
===================================================================
--- testsuites/libtests/Makefile.am	(revision d51538bdbe5ea9e71a7205e39fcef387fbdb4b39)
+++ testsuites/libtests/Makefile.am	(revision d2e31f70c12f6363cef79ffad781df6ec0acdfb5)
@@ -45,5 +45,5 @@
 
 if DLTESTS
-_SUBDIRS += dl01 dl02
+_SUBDIRS += dl01 dl02 dl03 dl04 dl05
 endif
 
Index: testsuites/libtests/configure.ac
===================================================================
--- testsuites/libtests/configure.ac	(revision d51538bdbe5ea9e71a7205e39fcef387fbdb4b39)
+++ testsuites/libtests/configure.ac	(revision d2e31f70c12f6363cef79ffad781df6ec0acdfb5)
@@ -128,4 +128,7 @@
 dl01/Makefile
 dl02/Makefile
+dl03/Makefile
+dl04/Makefile
+dl05/Makefile
 dumpbuf01/Makefile
 ftp01/Makefile
